/* 
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File util.h - contain various common utility functions
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef UTIL_H
#define UTIL_H

template<class T> inline void swap(T& a_, T& b_) { T t = a_; a_ = b_; b_ = t; }


enum eMsgType { msgInfo, msgWarning, msgError, msgFatal };
void Message (eMsgType eType_, const char* pcszFormat_, ...);

int open_log ();
void close_log ();

extern bool g_fTraceEnabled;

#define NOTRACE 1 ? (void)0 : ::TraceOutputString

#ifdef _DEBUG
#define TRACE ::TraceOutputString
void __cdecl TraceOutputString (const char *pcszFormat, ...);
void __cdecl TraceOutputString (const BYTE *pcb_, UINT uLen_=0, bool fASCII=TRUE, BOOL fNewline=TRUE);
#else
void __cdecl TraceOutputString (const char *, ...);
#define TRACE 1 ? (void)0 : ::TraceOutputString
inline void __cdecl TraceOutputString (const BYTE *pcb_, UINT uLen_, BOOL fASCII=TRUE, BOOL fNewline=TRUE);
#endif

#endif
