#ifndef FLOPPY_H
#define FLOPPY_H

#include "CStream.h"

namespace Floppy
{
	bool Init ();
	void Exit ();
}

class CFloppyStream : public CStream
{
	public:
		CFloppyStream (const char* pcszStream_, bool fReadOnly_);
		virtual ~CFloppyStream () { Close(); }

	public:
		static bool IsRecognised (const char* pcszStream_);
		static bool LoadDriver ();
		static bool UnloadDriver ();

	public:
		bool Rewind () { m_dwPos = 0; return true; }
		LONG Read (void* pvBuffer_, LONG lLen_) { return 0; }
		LONG Write (void* pvBuffer_, LONG lLen_) { return 0; }

		BYTE Read (int nSide_, int nTrack_, int nSector_, BYTE* pbData_, UINT* puSize_);
		BYTE Write (int nSide_, int nTrack_, int nSector_, BYTE* pbData_, UINT* puSize_);

	protected:
		HANDLE	m_hDevice;
		DWORD	m_dwPos;
/*
		bool	m_fChangeSupported;
		bool	m_afCached[2][83];
		BYTE	m_abCached[2][83][10][512];
*/

	protected:
		void Close ();

/*
		bool DIOC_Int13 (DIOC_REGISTERS* pRegs_);
		bool DIOC_Int21 (DIOC_REGISTERS* pRegs_);
		bool CheckChange ();
		bool Lock ();
		bool Unlock ();
		bool Reset ();
*/
};

#endif	// FLOPPY_H
