//	Notes:
//		Quick hack to use a modem on COM1 - worked with a simple terminal
//		program I found on a Utils disk (can't remember what - was a while ago)
//
//		Some of the info was extracted from Si Cooke's Termite, tho it was hard
//		to work out more than just some simple parameters.

#include "stdafx.h"

#include "Serial.h"



namespace Serial
{
static HANDLE hModem;
static BYTE abModem[1024];
static int nModemHead, nModemTail;


bool Init ()
{
	hModem = CreateFile("COM1", GENERIC_READ|GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);

	COMMTIMEOUTS cto;
	cto.ReadIntervalTimeout = MAXDWORD;
	cto.ReadTotalTimeoutMultiplier = cto.ReadTotalTimeoutConstant = 0;
	cto.WriteTotalTimeoutMultiplier = 50;
	cto.WriteTotalTimeoutConstant = 10;
	SetCommTimeouts(hModem, &cto);

	nModemHead = nModemTail = 0;
//	nModemTail = strlen(strcpy((PSTR)abModem, "\r\nOK\r\n"));

	return true;
}

void Exit ()
{
	if (hModem && (hModem != INVALID_HANDLE_VALUE))
	{
		CloseHandle(hModem);
		hModem = NULL;
	}
}


BYTE In (WORD wPort_)
{
	// Read more data if we've run out
	if (nModemHead == nModemTail)
	{
		DWORD dwModem = 0;
		ReadFile(hModem, abModem, sizeof abModem, &dwModem, NULL);
		nModemHead = 0;
		nModemTail = dwModem;
	}


/*
mr:           EQU  &F8EC ;Mode registers 1 and 2        (RD/WR)
sr:           EQU  &F9EC ;Status register               (RD)
csr:          EQU  &F9EC ;Clock select register         (WR)
cr:           EQU  &FAEC ;Command Register              (WR)

rhr:          EQU  &FBEC ;read holding register         (RD)
thr:          EQU  &FBEC ;transmit holding register     (WR)

acr:          EQU  &FCEC ;Auxilairy control register    (WR)

isr:          EQU  &FDEC ;Interrupt status register     (RD)
imr:          EQU  &FDEC ;Interrupt mask register       (WR)

ctu:          EQU  &FEEC ;counter hi byte               (RD)
ctur:         EQU  &FEEC ;counter hi byte preset        (WR)

ctl:          EQU  &FFEC ;counter lo byte               (RD)
ctlr:         EQU  &FFEC ;counter lo byte preset        (WR)




mr.port:       DEFW &00EC
sr.port:       DEFW &01EC
cr.port:       DEFW &02EC	// bit 4 Z for break
thr.port:      DEFW &03EC
acr.port:      DEFW &04EC
im.port:       DEFW &05EC	// interrupt status: bit 2 NZ for rx, bit 0 NZ for tx
ctu.port:      DEFW &06EC
ctl.port:      DEFW &07EC

mr1.init:      DEFB %11010011	// 211?
mr2.init:      DEFB %00010111	// 23?
csr.init:      DEFB %11001100	// 204?
cint.init:     EQU  %00000101	// 5
*/

	switch (HIBYTE(wPort_))
	{
		case 0x00:
			return 0x00;

		case 0x01:
		{
			BYTE bStatus = 0x08;
			if (nModemHead != nModemTail) bStatus |= 0x01;
			return  bStatus;
		}

		case 0x03:	return abModem[nModemHead++];

		case 0x05:
			return 0x00;

		default:
			return 0x00;
	}
}

void Out (WORD wPort_, BYTE bVal_)
{
/*
	port	value written
	---------------------
	0x02ec, 0x10 (.)	// disable rx & tx, set MR pointer to MR1
	0x00ec, 0x93 ()	// mr1 init
	0x00ec, 0x17 (.)	// mr2 init
	0x01ec, 0x88 ()
	0x04ec, 0x38 (8)	// set power-down/timer mode
	0x05ec, 0x00		// initialise interrupts
	0x06ec, 0x00
	0x07ec, 0x00
	0x02ec, 0x20 ( )
	0x02ec, 0x30 (0)
	0x02ec, 0x40 (@)
	0x02ec, 0x50 (P)

	0x02ec, 0x05 (.)	// 0x5a0 = 1440 = 14400bps?

	0x02ec, 0xa0 ()
*/
	switch (HIBYTE(wPort_))
	{
		case 0x03:
		{
			DWORD dwWritten;
			WriteFile(hModem, &bVal_, 1, &dwWritten, NULL);
			DWORD dwError = GetLastError();
			break;
		}
	}
}


};	// namespace Serial
